#include <time.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

enum cron_parse_error {
	CPEParseOk = 0,
	CPEParseInvalidExpression = 1,
	CPEParseInvalidNumber = 2,
	CPEParseOutOfRange = 3
};

struct cron_expression {
	uint8_t *minutes;
	uint8_t *hours;
	uint8_t *days;
	uint8_t *months;
	uint8_t minute_count;
	uint8_t hour_count;
	uint8_t day_count;
	uint8_t month_count;
};

struct cron_simple_time {
	int year;
	int month;
	int day;
	int hour;
	int minute;
};

struct cron_expression *ce_init();

void cron_ce_free(struct cron_expression *ce);

/**
 * Given a 
 */
int cron_ce_next(struct cron_simple_time *out, struct cron_expression *ce, struct ce_simple_time *ref);

int cron_ce_next_from_now(struct simple_time *out, struct cron_expression *ce);

enum cron_parse_error cron_ce_parse_expression(struct cron_expression *out, char *s);
