module expression

import time

pub fn parse_expression(exp string) !&CronExpression {
	out := C.ce_init()
	res := C.ce_parse_expression(out, exp.str)

	if res != 0 {
		return error('yuhh')
	}

	return out
}

pub fn (ce &CronExpression) free() {
	C.ce_free(ce)
}

pub fn (ce &CronExpression) next(ref time.Time) !time.Time {
	st := C.cron_simple_time{
		year: ref.year
		month: ref.month
		day: ref.day
		hour: ref.hour
		minute: ref.minute
	}

	out := C.cron_simple_time{}
	res := C.ce_next(&out, ce, &st)

	if res != 0 {
		return error('yuhh')
	}

	return time.new_time(time.Time{
		year: out.year
		month: out.month
		day: out.day
		hour: out.hour
		minute: out.minute
	})
}

pub fn (ce &CronExpression) next_from_now() !time.Time {
	out := C.cron_simple_time{}
	res := C.ce_next_from_now(&out, ce)

	if res != 0 {
		return error('yuhh')
	}

	return time.new_time(time.Time{
		year: out.year
		month: out.month
		day: out.day
		hour: out.hour
		minute: out.minute
	})
}

// next_n returns the n next occurences of the expression, given a starting
// time.
pub fn (ce &CronExpression) next_n(ref time.Time, n int) ![]time.Time {
	mut times := []time.Time{cap: n}

	times << ce.next(ref)!

	for i in 1 .. n {
		times << ce.next(times[i - 1])!
	}

	return times
}
